.docker_build:
  stage: build
  image: docker:stable
  variables:
    DEPLOY_DOCKERPATH: "./docker"
    DEPLOY_SOURCE: "./backend"
  services:
    - docker:dind
  before_script:
    - export DEPLOY_WHICH="$(echo "${CI_JOB_NAME}" | tr A-Z a-z)"
    - export DEPLOY_FILE=${CI_JOB_NAME}
  script:
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
    - echo "$(ls -al .)"
    - echo "$(ls -laR .)"
    - echo "docker build
        --build-arg CI_COMMIT_SHORT_SHA_ARG=${CI_COMMIT_SHORT_SHA}
        -t ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CI_PROJECT_NAME}-${DEPLOY_WHICH}:${CI_COMMIT_REF_SLUG}
        -f ${DEPLOY_DOCKERPATH}/Dockerfile.${DEPLOY_FILE} ."
    - docker build
        --build-arg CI_COMMIT_SHORT_SHA_ARG=${CI_COMMIT_SHORT_SHA}
        -t ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CI_PROJECT_NAME}-${DEPLOY_WHICH}:${CI_COMMIT_REF_SLUG}
        -f ${DEPLOY_DOCKERPATH}/Dockerfile.${DEPLOY_FILE} .
    - docker push ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CI_PROJECT_NAME}-${DEPLOY_WHICH}:${CI_COMMIT_REF_SLUG} 
    - docker tag
        ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CI_PROJECT_NAME}-${DEPLOY_WHICH}:${CI_COMMIT_REF_SLUG} 
        ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CI_PROJECT_NAME}-${DEPLOY_WHICH}:latest
    - docker push ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CI_PROJECT_NAME}-${DEPLOY_WHICH}:latest
    - if [[ ! -z "${CI_COMMIT_TAG}" ]]; then docker tag
        ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CI_PROJECT_NAME}-${DEPLOY_WHICH}:${CI_COMMIT_REF_SLUG}
        ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CI_PROJECT_NAME}-${DEPLOY_WHICH}:${CI_COMMIT_TAG}; fi
    - if [[ ! -z "${CI_COMMIT_TAG}" ]]; then docker push ${CI_REGISTRY}/${CI_PROJECT_PATH}/${CI_PROJECT_NAME}-${DEPLOY_WHICH}:${CI_COMMIT_TAG}; fi
 # rules:
 #   - changes:
 #       - ${DEPLOY_DOCKERPATH}/Dockerfile.${DEPLOY_FILE}
 #       - ${DEPLOY_SOURCE}/${DEPLOY_WHICH}/**
  tags:
     - docker
